#include <stdio.h>
#include <stdlib.h>

char lab[1002][1002];

long maxsum(long a[])
{
	int i, j;
	long m=0;
	for (i=0; i<4; i++)
		for (j=0; j<4; j++)
			if (i != j && a[i] + a[j] > m)
				m = a[i] + a[j];
	return m;
}

long max(long a[])
{
	int i;
	long m=0;
	for (i=0; i<4; i++)
		if (a[i] > m)
			m = a[i];
	return m;
}

long longest(long x, long y)
{
	int num;
	long mx = 1;
	long a[4];
	long dx, dy;
	long xx, yy;
	long ms, mn;
	
	while (1)
	{
#ifdef DEBUG
		printf("at (%ld, %ld), ", y, x);
#endif
		num = 0;
		lab[y][x] = 'd';
		if (lab[y][x+1] == '.')
			num++;
		if (lab[y][x-1] == '.')
			num++;
		if (lab[y+1][x] == '.')
			num++;
		if (lab[y-1][x] == '.')
			num++;
#ifdef DEBUG
		printf("num = %d\n", num);
#endif
		if (!num)
		{
#ifdef DEBUG
			printf("returns %ld\n", mx);
#endif
			return mx;
		}
		if (num > 1)
		{
			a[0] = 0;
			a[1] = 0;
			a[2] = 0;
			a[3] = 0;
			if (lab[y][x+1] == '.') {
				dx = x+1;
				dy = y;
				a[0] = longest(x+1, y);
			}
			if (lab[y][x-1] == '.') {
				dx = x-1;
				dy = y;
				a[1] = longest(x-1, y);
			}
			if (lab[y+1][x] == '.') {
				dx = x;
				dy = y+1;
				a[2] = longest(x, y+1);
			}
			if (lab[y-1][x] == '.') {
				dx = x;
				dy = y-1;
				a[3] = longest(x, y-1);
			}
			ms = maxsum(a);
			mn = mx + max(a);
#ifdef DEBUG
			printf("mx = %ld, ms = %ld, mn = %ld\n", mx, ms, mn);
#endif
			if (ms > mn)
				return ms;
			else
				return mn;
		}
		mx++;
		xx = x;
		yy = y;
		if (lab[yy][xx+1] == '.')
			x++;
		else if (lab[yy][xx-1] == '.')
			x--;
		else if (lab[yy+1][xx] == '.')
			y++;
		else if (lab[yy-1][xx] == '.')
			y--;
	}
}

int main()
{
	long T;
	long w, h;
	long x, y;
	long sx, sy;
	long len;
	int b;

	char *p;

	char lbuf[1024];
	fgets(lbuf, 1024, stdin);
	T = strtol(lbuf, NULL, 10);
	while (T--)
	{
		fgets(lbuf, 1024, stdin);
		w = strtol(lbuf, &p, 10);
		h = strtol(p, NULL, 10);
		sx = 0; sy = 0;
		len = 0;
		for (x=0; x<=w+1; x++)
		{
			lab[0][x] = '#';
			lab[h+1][x] = '#';
		}
		for (y=1; y<=h; y++)
		{
			lab[y][0] = '#';
			lab[y][w+1] = '#';
			for (x=1; x<=w; x++)
			{
				lab[y][x] = getc(stdin);
			}
			getc(stdin); /* newline */
		}
		b = 0;
		for (y=1; y<=h; y++)
		{
			for (x=1; x<=w; x++)
				if (lab[y][x] == '.' &&
						((lab[y-1][x] == '#') + (lab[y+1][x] == '#') + (lab[y][x-1] == '#') + (lab[y][x+1] == '#')) == 3)
				{
					sx = x;
					sy = y;
					b = 1;
					break;
				}
			if (b)
				break;
		}
#ifdef DEBUG
		for (y=0; y<=h+1; y++)
		{
			for (x=0; x<=w+1; x++)
				putc(lab[y][x], stdout);
			putc('\n', stdout);
		}
				
#endif
		if (sx && sy)
		{
#ifdef DEBUG
			if (lab[2][4] == '.')
			{
				sx = 4;
				sy = 2;
			}
#endif
			len = longest(sx, sy) - 1;
			printf("Maximum rope length is %ld.\n", len);
		} else
			printf("Maximum rope length is 0.\n");
	}
    return 0;
}
